Index: /palm/trunk/SOURCE/Makefile
===================================================================
--- /palm/trunk/SOURCE/Makefile	(revision 2231)
+++ /palm/trunk/SOURCE/Makefile	(revision 2232)
@@ -20,5 +20,6 @@
 # Current revisions:
 # ------------------
-# 
+# +dependencies for surface_mod
+# -wall_fluxes
 # 
 # Former revisions:
@@ -351,5 +352,5 @@
 	read_3d_binary.f90 read_var_list.f90 run_control.f90 \
 	set_slicer_attributes_dvrp.f90 singleton_mod.f90 sor.f90 spectra_mod.f90 \
-	subsidence_mod.f90 sum_up_3d_data.f90 \
+	subsidence_mod.f90 sum_up_3d_data.f90 surface_mod.f90 \
 	surface_coupler.f90 surface_layer_fluxes_mod.f90 swap_timelevel.f90 temperton_fft_mod.f90 \
 	time_integration.f90 time_to_string.f90 timestep.f90 \
@@ -369,5 +370,5 @@
 	user_lpm_init.f90 user_lpm_set_attributes.f90 user_module.f90 \
 	user_parin.f90 user_read_restart_data.f90 \
-	user_spectra.f90 user_statistics.f90 virtual_flight_mod.f90 wall_fluxes.f90 \
+	user_spectra.f90 user_statistics.f90 virtual_flight_mod.f90 \
 	wind_turbine_model_mod.f90 write_3d_binary.f90 write_var_list.f90
 
@@ -413,7 +414,7 @@
 advec_w_pw.o: modules.o mod_kinds.o
 advec_w_up.o: modules.o mod_kinds.o
-average_3d_data.o: modules.o cpulog_mod.o mod_kinds.o land_surface_model_mod.o \
+average_3d_data.o: modules.o cpulog_mod.o mod_kinds.o exchange_horiz_2d.o land_surface_model_mod.o \
 	radiation_model_mod.o urban_surface_mod.o
-boundary_conds.o: modules.o mod_kinds.o pmc_interface_mod.o
+boundary_conds.o: modules.o mod_kinds.o pmc_interface_mod.o surface_mod.o
 buoyancy.o: modules.o mod_kinds.o
 calc_mean_profile.o: modules.o mod_kinds.o
@@ -445,23 +446,23 @@
 data_output_2d.o: modules.o cpulog_mod.o mod_kinds.o mod_particle_attributes.o \
    netcdf_interface_mod.o land_surface_model_mod.o radiation_model_mod.o \
-   urban_surface_mod.o
+   surface_mod.o urban_surface_mod.o
 data_output_3d.o: modules.o cpulog_mod.o mod_kinds.o mod_particle_attributes.o \
    netcdf_interface_mod.o land_surface_model_mod.o urban_surface_mod.o
 diffusion_e.o: modules.o mod_kinds.o microphysics_mod.o \
-   mod_particle_attributes.o
-diffusion_s.o: modules.o mod_kinds.o
-diffusion_u.o: modules.o mod_kinds.o wall_fluxes.o
-diffusion_v.o: modules.o mod_kinds.o wall_fluxes.o
-diffusion_w.o: modules.o mod_kinds.o wall_fluxes.o
-diffusivities.o: modules.o mod_kinds.o
+   mod_particle_attributes.o surface_mod.o
+diffusion_s.o: modules.o mod_kinds.o surface_mod.o
+diffusion_u.o: modules.o mod_kinds.o surface_mod.o
+diffusion_v.o: modules.o mod_kinds.o surface_mod.o
+diffusion_w.o: modules.o mod_kinds.o surface_mod.o
+diffusivities.o: modules.o mod_kinds.o surface_mod.o
 disturb_field.o: modules.o cpulog_mod.o mod_kinds.o random_function_mod.o \
                  random_generator_parallel_mod.o
-disturb_heatflux.o: modules.o cpulog_mod.o mod_kinds.o
-eqn_state_seawater.o: modules.o mod_kinds.o
+disturb_heatflux.o: modules.o cpulog_mod.o mod_kinds.o random_generator_parallel_mod.o surface_mod.o
+eqn_state_seawater.o: modules.o mod_kinds.o surface_mod.o
 exchange_horiz.o: modules.o cpulog_mod.o mod_kinds.o
 exchange_horiz_2d.o: modules.o cpulog_mod.o mod_kinds.o pmc_interface_mod.o
 fft_xy_mod.o: modules.o mod_kinds.o singleton_mod.o temperton_fft_mod.o
 flow_statistics.o: modules.o cpulog_mod.o mod_kinds.o land_surface_model_mod.o \
-   netcdf_interface_mod.o radiation_model_mod.o
+   netcdf_interface_mod.o radiation_model_mod.o surface_mod.o
 global_min_max.o: modules.o mod_kinds.o
 header.o: modules.o cpulog_mod.o mod_kinds.o netcdf_interface_mod.o land_surface_model_mod.o\
@@ -470,14 +471,14 @@
 inflow_turbulence.o: modules.o cpulog_mod.o mod_kinds.o
 init_1d_model.o: modules.o mod_kinds.o
-init_3d_model.o: modules.o mod_kinds.o advec_ws.o cpulog_mod.o land_surface_model_mod.o \
+init_3d_model.o: modules.o mod_kinds.o advec_ws.o cpulog_mod.o disturb_heatflux.o land_surface_model_mod.o \
    lpm_init.o ls_forcing_mod.o netcdf_interface_mod.o plant_canopy_model_mod.o \
    radiation_model_mod.o random_function_mod.o random_generator_parallel_mod.o \
-   surface_layer_fluxes_mod.o microphysics_mod.o mod_particle_attributes.o \
-   urban_surface_mod.o virtual_flight_mod.o wind_turbine_model_mod.o 
+   microphysics_mod.o mod_particle_attributes.o surface_layer_fluxes_mod.o \
+   urban_surface_mod.o virtual_flight_mod.o surface_mod.o wind_turbine_model_mod.o 
 init_advec.o: modules.o mod_kinds.o
 init_cloud_physics.o: modules.o mod_kinds.o
 init_coupling.o: modules.o mod_kinds.o
 init_dvrp.o: modules.o mod_kinds.o
-init_grid.o: modules.o mod_kinds.o advec_ws.o
+init_grid.o: modules.o mod_kinds.o advec_ws.o netcdf_interface_mod.o surface_mod.o
 init_masks.o: modules.o mod_kinds.o netcdf_interface_mod.o
 init_ocean.o: modules.o eqn_state_seawater.o mod_kinds.o
@@ -487,5 +488,5 @@
 init_slope.o: modules.o mod_kinds.o
 interaction_droplets_ptq.o: modules.o mod_kinds.o
-land_surface_model_mod.o: modules.o mod_kinds.o radiation_model_mod.o
+land_surface_model_mod.o: modules.o mod_kinds.o radiation_model_mod.o surface_mod.o
 local_stop.o: modules.o mod_kinds.o pmc_interface_mod.o
 local_tremain.o: modules.o cpulog_mod.o mod_kinds.o
@@ -519,5 +520,5 @@
 ls_forcing_mod.o: modules.o cpulog_mod.o mod_kinds.o
 message.o: modules.o mod_kinds.o pmc_interface_mod.o
-microphysics_mod.o: modules.o cpulog_mod.o mod_kinds.o
+microphysics_mod.o: modules.o cpulog_mod.o mod_kinds.o surface_mod.o
 modules.o: modules.f90 mod_kinds.o
 mod_kinds.o: mod_kinds.f90
@@ -546,7 +547,8 @@
 poismg_noopt.o: modules.o cpulog_mod.o mod_kinds.o
 posix_calls_from_fortran.o: posix_calls_from_fortran.f90
-pres.o: modules.o cpulog_mod.o mod_kinds.o poisfft_mod.o poismg_mod.o pmc_interface_mod.o
+pres.o: modules.o cpulog_mod.o mod_kinds.o poisfft_mod.o poismg_mod.o pmc_interface_mod.o \
+   surface_mod.o
 print_1d.o: modules.o cpulog_mod.o mod_kinds.o
-production_e.o: modules.o mod_kinds.o wall_fluxes.o
+production_e.o: modules.o mod_kinds.o surface_mod.o
 prognostic_equations.o: modules.o advec_s_pw.o advec_s_up.o advec_s_bc.o advec_u_pw.o \
 	advec_u_up.o advec_v_pw.o advec_v_up.o advec_w_pw.o advec_w_up.o \
@@ -555,5 +557,5 @@
 	eqn_state_seawater.o mod_kinds.o microphysics_mod.o \
 	nudging_mod.o plant_canopy_model_mod.o production_e.o radiation_model_mod.o \
-	subsidence_mod.o urban_surface_mod.o user_actions.o wind_turbine_model_mod.o
+	subsidence_mod.o surface_mod.o user_actions.o wind_turbine_model_mod.o
 progress_bar_mod.o: modules.o mod_kinds.o
 radiation_model_mod.o : modules.o mod_particle_attributes.o microphysics_mod.o
@@ -563,5 +565,5 @@
 read_3d_binary.o: modules.o cpulog_mod.o mod_kinds.o \
    land_surface_model_mod.o radiation_model_mod.o random_function_mod.o random_generator_parallel_mod.o \
-   spectra_mod.o
+   spectra_mod.o surface_mod.o
 read_var_list.o: modules.o mod_kinds.o netcdf_interface_mod.o plant_canopy_model_mod.o \
    spectra_mod.o microphysics_mod.o urban_surface_mod.o virtual_flight_mod.o
@@ -573,16 +575,17 @@
 subsidence_mod.o: modules.o mod_kinds.o
 sum_up_3d_data.o: modules.o cpulog_mod.o mod_kinds.o land_surface_model_mod.o \
-                  radiation_model_mod.o urban_surface_mod.o
+                  radiation_model_mod.o surface_mod.o urban_surface_mod.o
 surface_coupler.o: modules.o cpulog_mod.o mod_kinds.o
-surface_layer_fluxes_mod.o: modules.o mod_kinds.o land_surface_model_mod.o \
-	urban_surface_mod.o
+surface_layer_fluxes_mod.o: modules.o mod_kinds.o exchange_horiz_2d.o land_surface_model_mod.o \
+	urban_surface_mod.o surface_mod.o
+surface_mod.o: modules.o mod_kinds.o init_pegrid.o
 swap_timelevel.o: modules.o cpulog_mod.o mod_kinds.o land_surface_model_mod.o \
    pmc_interface_mod.o urban_surface_mod.o
 temperton_fft_mod.o: modules.o mod_kinds.o
 time_integration.o: modules.o advec_ws.o buoyancy.o calc_mean_profile.o \
-	cpulog_mod.o data_output_flight.o interaction_droplets_ptq.o land_surface_model_mod.o \
+	cpulog_mod.o data_output_flight.o disturb_heatflux.o interaction_droplets_ptq.o land_surface_model_mod.o \
 	ls_forcing_mod.o mod_kinds.o nudging_mod.o pmc_interface_mod.o production_e.o \
 	prognostic_equations.o progress_bar_mod.o radiation_model_mod.o \
-	spectra_mod.o user_actions.o surface_layer_fluxes_mod.o microphysics_mod.o \
+	spectra_mod.o user_actions.o microphysics_mod.o surface_layer_fluxes_mod.o surface_mod.o \
 	urban_surface_mod.o virtual_flight_mod.o wind_turbine_model_mod.o
 time_to_string.o: mod_kinds.o
@@ -600,5 +603,5 @@
    netcdf_interface_mod.o
 user_check_parameters.o: modules.o mod_kinds.o user_module.o
-user_data_output_2d.o: modules.o mod_kinds.o user_module.o
+user_data_output_2d.o: modules.o mod_kinds.o surface_mod.o user_module.o
 user_data_output_3d.o: modules.o mod_kinds.o user_module.o
 user_data_output_mask.o: modules.o mod_kinds.o user_module.o
@@ -609,11 +612,11 @@
 user_header.o: modules.o mod_kinds.o user_module.o
 user_init.o: modules.o mod_kinds.o netcdf_interface_mod.o user_module.o
-user_init_3d_model.o: modules.o mod_kinds.o user_module.o
+user_init_3d_model.o: modules.o mod_kinds.o surface_mod.o user_module.o
 user_init_flight.o: modules.o mod_kinds.o netcdf_interface_mod.o user_module.o
 user_init_grid.o: modules.o mod_kinds.o user_module.o
-user_init_land_surface.o: modules.o mod_kinds.o user_module.o land_surface_model_mod.o netcdf_interface_mod.o
+user_init_land_surface.o: modules.o mod_kinds.o surface_mod.o user_module.o land_surface_model_mod.o netcdf_interface_mod.o
 user_init_plant_canopy.o: modules.o mod_kinds.o user_module.o plant_canopy_model_mod.o
 user_init_radiation.o: modules.o mod_kinds.o user_module.o radiation_model_mod.o
-user_init_urban_surface.o: modules.o mod_kinds.o user_module.o urban_surface_mod.o
+user_init_urban_surface.o: modules.o mod_kinds.o surface_mod.o user_module.o urban_surface_mod.o
 user_last_actions.o: modules.o mod_kinds.o user_module.o
 user_lpm_advec.o: modules.o mod_kinds.o user_module.o
@@ -626,9 +629,8 @@
 user_statistics.o: modules.o mod_kinds.o netcdf_interface_mod.o user_module.o
 virtual_flight_mod.o: modules.o cpulog_mod.o mod_kinds.o netcdf_interface_mod.o user_init_flight.o user_flight.o
-wall_fluxes.o: modules.o mod_kinds.o
 wind_turbine_model_mod.o: modules.o cpulog_mod.o mod_kinds.o
 write_3d_binary.o: modules.o cpulog_mod.o mod_kinds.o \
 	radiation_model_mod.o random_function_mod.o random_generator_parallel_mod.o \
-	spectra_mod.o
+	spectra_mod.o surface_mod.o
 write_var_list.o: modules.o mod_kinds.o netcdf_interface_mod.o plant_canopy_model_mod.o\
    spectra_mod.o microphysics_mod.o urban_surface_mod.o virtual_flight_mod.o
Index: /palm/trunk/SOURCE/advec_s_pw.f90
===================================================================
--- /palm/trunk/SOURCE/advec_s_pw.f90	(revision 2231)
+++ /palm/trunk/SOURCE/advec_s_pw.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! topography representation via flags
 ! 
 ! Former revisions:
@@ -104,6 +104,6 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzb_s_inner,&
-                  nzt
+           ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb,             &
+                  nzt, wall_flags_0
 
        USE kinds
@@ -125,7 +125,7 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_s_inner(j,i)+1, nzt
-                tend(k,j,i) = tend(k,j,i)                                      &
-              -0.5_wp * ( ( u(k,j,i+1) - u_gtrans ) * ( sk(k,j,i+1) - sk(k,j,i) ) &
+             DO  k = nzb+1, nzt
+                tend(k,j,i) = tend(k,j,i) +                                       &
+            ( -0.5_wp * ( ( u(k,j,i+1) - u_gtrans ) * ( sk(k,j,i+1) - sk(k,j,i) ) &
                         - ( u(k,j,i)   - u_gtrans ) * ( sk(k,j,i-1) - sk(k,j,i) ) &
                         ) * ddx                                                   &
@@ -135,5 +135,6 @@
               -         (   w(k,j,i)                * ( sk(k+1,j,i) - sk(k,j,i) ) &
                         -   w(k-1,j,i)              * ( sk(k-1,j,i) - sk(k,j,i) ) &
-                        ) * dd2zu(k)
+                        ) * dd2zu(k)                                              &
+            ) * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
              ENDDO
           ENDDO
@@ -160,5 +161,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxlg, nxrg, nyng, nysg, nzb, nzb_s_inner, nzt
+           ONLY:  nxlg, nxrg, nyng, nysg, nzb, nzt, wall_flags_0
 
        USE kinds
@@ -178,7 +179,7 @@
 
 
-       DO  k = nzb_s_inner(j,i)+1, nzt
-          tend(k,j,i) = tend(k,j,i)                                            &
-              -0.5_wp * ( ( u(k,j,i+1) - u_gtrans ) * ( sk(k,j,i+1) - sk(k,j,i) ) &
+       DO  k = nzb+1, nzt
+          tend(k,j,i) = tend(k,j,i) +                                             &
+            ( -0.5_wp * ( ( u(k,j,i+1) - u_gtrans ) * ( sk(k,j,i+1) - sk(k,j,i) ) &
                         - ( u(k,j,i)   - u_gtrans ) * ( sk(k,j,i-1) - sk(k,j,i) ) &
                         ) * ddx                                                   &
@@ -188,5 +189,6 @@
               -         (   w(k,j,i)                * ( sk(k+1,j,i) - sk(k,j,i) ) &
                         -   w(k-1,j,i)              * ( sk(k-1,j,i) - sk(k,j,i) ) &
-                        ) * dd2zu(k)
+                        ) * dd2zu(k)                                              &
+            ) * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
        ENDDO
 
Index: /palm/trunk/SOURCE/advec_s_up.f90
===================================================================
--- /palm/trunk/SOURCE/advec_s_up.f90	(revision 2231)
+++ /palm/trunk/SOURCE/advec_s_up.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! topography representation via flags
 ! 
 ! Former revisions:
@@ -104,6 +104,6 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzb_s_inner,&
-                  nzt
+           ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt,        &
+                  wall_flags_0
 
        USE kinds
@@ -128,5 +128,5 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_s_inner(j,i)+1, nzt
+             DO  k = nzb+1, nzt
 !
 !--             x-direction
@@ -134,8 +134,12 @@
                 IF ( ukomp > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - ukomp *                         &
-                                         ( sk(k,j,i) - sk(k,j,i-1) ) * ddx
+                                         ( sk(k,j,i) - sk(k,j,i-1) ) * ddx     &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                 ELSE
                    tend(k,j,i) = tend(k,j,i) - ukomp *                         &
-                                         ( sk(k,j,i+1) - sk(k,j,i) ) * ddx
+                                         ( sk(k,j,i+1) - sk(k,j,i) ) * ddx     &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                 ENDIF
 !
@@ -144,8 +148,12 @@
                 IF ( vkomp > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - vkomp *                         &
-                                         ( sk(k,j,i) - sk(k,j-1,i) ) * ddy
+                                         ( sk(k,j,i) - sk(k,j-1,i) ) * ddy     &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                 ELSE
                    tend(k,j,i) = tend(k,j,i) - vkomp *                         &
-                                         ( sk(k,j+1,i) - sk(k,j,i) ) * ddy
+                                         ( sk(k,j+1,i) - sk(k,j,i) ) * ddy     &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                 ENDIF
 !
@@ -154,8 +162,12 @@
                 IF ( wkomp > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - wkomp *                         &
-                                         ( sk(k,j,i) - sk(k-1,j,i) ) * ddzu(k)
+                                         ( sk(k,j,i) - sk(k-1,j,i) ) * ddzu(k) &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                 ELSE
                    tend(k,j,i) = tend(k,j,i) - wkomp *                         &
-                                         ( sk(k+1,j,i)-sk(k,j,i) ) * ddzu(k+1)
+                                         ( sk(k+1,j,i)-sk(k,j,i) ) * ddzu(k+1) &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                 ENDIF
 
@@ -184,5 +196,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxlg, nxrg, nyng, nysg, nzb, nzb_s_inner, nzt
+           ONLY:  nxlg, nxrg, nyng, nysg, nzb, nzt, wall_flags_0
 
        USE kinds
@@ -206,5 +218,5 @@
 
 
-       DO  k = nzb_s_inner(j,i)+1, nzt
+       DO  k = nzb+1, nzt
 !
 !--       x-direction
@@ -212,8 +224,12 @@
           IF ( ukomp > 0.0_wp )  THEN
              tend(k,j,i) = tend(k,j,i) - ukomp *                               &
-                                         ( sk(k,j,i) - sk(k,j,i-1) ) * ddx
+                                         ( sk(k,j,i) - sk(k,j,i-1) ) * ddx     &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
           ELSE
              tend(k,j,i) = tend(k,j,i) - ukomp *                               &
-                                         ( sk(k,j,i+1) - sk(k,j,i) ) * ddx
+                                         ( sk(k,j,i+1) - sk(k,j,i) ) * ddx     &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
           ENDIF
 !
@@ -222,8 +238,12 @@
           IF ( vkomp > 0.0_wp )  THEN
              tend(k,j,i) = tend(k,j,i) - vkomp *                               &
-                                         ( sk(k,j,i) - sk(k,j-1,i) ) * ddy
+                                         ( sk(k,j,i) - sk(k,j-1,i) ) * ddy     &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
           ELSE
              tend(k,j,i) = tend(k,j,i) - vkomp *                               &
-                                         ( sk(k,j+1,i) - sk(k,j,i) ) * ddy
+                                         ( sk(k,j+1,i) - sk(k,j,i) ) * ddy     &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
           ENDIF
 !
@@ -232,8 +252,12 @@
           IF ( wkomp > 0.0_wp )  THEN
              tend(k,j,i) = tend(k,j,i) - wkomp *                               &
-                                         ( sk(k,j,i) - sk(k-1,j,i) ) * ddzu(k)
+                                         ( sk(k,j,i) - sk(k-1,j,i) ) * ddzu(k) &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
           ELSE
              tend(k,j,i) = tend(k,j,i) - wkomp *                               &
-                                         ( sk(k+1,j,i)-sk(k,j,i) ) * ddzu(k+1)
+                                         ( sk(k+1,j,i)-sk(k,j,i) ) * ddzu(k+1) &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
           ENDIF
 
Index: /palm/trunk/SOURCE/advec_u_pw.f90
===================================================================
--- /palm/trunk/SOURCE/advec_u_pw.f90	(revision 2231)
+++ /palm/trunk/SOURCE/advec_u_pw.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! topography representation via flags
 ! 
 ! Former revisions:
@@ -96,5 +96,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxlu, nxr, nyn, nys, nzb_u_inner, nzt
+           ONLY:  nxlu, nxr, nyn, nys, nzb, nzt, wall_flags_0
 
        USE kinds
@@ -114,5 +114,5 @@
        DO  i = nxlu, nxr
           DO  j = nys, nyn
-             DO  k = nzb_u_inner(j,i)+1, nzt
+             DO  k = nzb+1, nzt
                 tend(k,j,i) = tend(k,j,i) - 0.25_wp * (                        &
                          ( u(k,j,i+1) * ( u(k,j,i+1) + u(k,j,i) - gu )         &
@@ -123,5 +123,7 @@
                          - u(k-1,j,i) * ( w(k-1,j,i) + w(k-1,j,i-1) ) )        &
                                                                   * ddzw(k)    &
-                                                      )
+                                                      )                        &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 1 ) )
              ENDDO
           ENDDO
@@ -148,5 +150,5 @@
 
        USE indices,                                                            &
-           ONLY:  nzb_u_inner, nzt
+           ONLY:  nzb, nzt, wall_flags_0
 
        USE kinds
@@ -164,5 +166,5 @@
        gu = 2.0_wp * u_gtrans
        gv = 2.0_wp * v_gtrans
-       DO  k = nzb_u_inner(j,i)+1, nzt
+       DO  k = nzb+1, nzt
           tend(k,j,i) = tend(k,j,i) - 0.25_wp * (                              &
                          ( u(k,j,i+1) * ( u(k,j,i+1) + u(k,j,i) - gu )         &
@@ -173,5 +175,7 @@
                          - u(k-1,j,i) * ( w(k-1,j,i) + w(k-1,j,i-1) ) )        &
                                                                   * ddzw(k)    &
-                                                )
+                                                )                              &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 1 ) )
        ENDDO
 
Index: /palm/trunk/SOURCE/advec_u_up.f90
===================================================================
--- /palm/trunk/SOURCE/advec_u_up.f90	(revision 2231)
+++ /palm/trunk/SOURCE/advec_u_up.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! topography representation via flags
 ! 
 ! Former revisions:
@@ -95,5 +95,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxlu, nxr, nyn, nys, nzb_u_inner, nzt
+           ONLY:  nxlu, nxr, nyn, nys, nzb, nzt, wall_flags_0
 
        USE kinds
@@ -113,5 +113,5 @@
        DO  i = nxlu, nxr
           DO  j = nys, nyn
-             DO  k = nzb_u_inner(j,i)+1, nzt
+             DO  k = nzb+1, nzt
 !
 !--             x-direction
@@ -119,8 +119,12 @@
                 IF ( ukomp > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - ukomp *                         &
-                                         ( u(k,j,i) - u(k,j,i-1) ) * ddx
+                                         ( u(k,j,i) - u(k,j,i-1) ) * ddx       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 1 ) )
                 ELSE
                    tend(k,j,i) = tend(k,j,i) - ukomp *                         &
-                                          ( u(k,j,i+1) - u(k,j,i) ) * ddx
+                                          ( u(k,j,i+1) - u(k,j,i) ) * ddx      &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 1 ) )
                 ENDIF
 !
@@ -130,8 +134,12 @@
                 IF ( vkomp > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - vkomp *                         &
-                                         ( u(k,j,i) - u(k,j-1,i) ) * ddy
+                                         ( u(k,j,i) - u(k,j-1,i) ) * ddy       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 1 ) )
                 ELSE
                    tend(k,j,i) = tend(k,j,i) - vkomp *                         &
-                                         ( u(k,j+1,i) - u(k,j,i) ) * ddy
+                                         ( u(k,j+1,i) - u(k,j,i) ) * ddy       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 1 ) )
                 ENDIF
 !
@@ -141,8 +149,12 @@
                 IF ( wkomp > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - wkomp *                         &
-                                         ( u(k,j,i) - u(k-1,j,i) ) * ddzu(k)
+                                         ( u(k,j,i) - u(k-1,j,i) ) * ddzu(k)   &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 1 ) )
                 ELSE
                    tend(k,j,i) = tend(k,j,i) - wkomp *                         &
-                                         ( u(k+1,j,i) - u(k,j,i) ) * ddzu(k+1)
+                                         ( u(k+1,j,i) - u(k,j,i) ) * ddzu(k+1) &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 1 ) )
                 ENDIF
 
@@ -171,5 +183,5 @@
 
        USE indices,                                                            &
-           ONLY:  nzb_u_inner, nzt
+           ONLY:  nzb, nzt, wall_flags_0
 
        USE kinds
@@ -187,5 +199,5 @@
 
 
-       DO  k = nzb_u_inner(j,i)+1, nzt
+       DO  k = nzb+1, nzt
 !
 !--       x-direction
@@ -193,8 +205,12 @@
           IF ( ukomp > 0.0_wp )  THEN
              tend(k,j,i) = tend(k,j,i) - ukomp *                               &
-                                         ( u(k,j,i) - u(k,j,i-1) ) * ddx
+                                         ( u(k,j,i) - u(k,j,i-1) ) * ddx       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 1 ) )
           ELSE
              tend(k,j,i) = tend(k,j,i) - ukomp *                               &
-                                         ( u(k,j,i+1) - u(k,j,i) ) * ddx
+                                         ( u(k,j,i+1) - u(k,j,i) ) * ddx       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 1 ) )
           ENDIF
 !
@@ -204,8 +220,12 @@
           IF ( vkomp > 0.0_wp )  THEN
              tend(k,j,i) = tend(k,j,i) - vkomp *                               &
-                                         ( u(k,j,i) - u(k,j-1,i) ) * ddy
+                                         ( u(k,j,i) - u(k,j-1,i) ) * ddy       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 1 ) )
           ELSE
              tend(k,j,i) = tend(k,j,i) - vkomp *                               &
-                                         ( u(k,j+1,i) - u(k,j,i) ) * ddy
+                                         ( u(k,j+1,i) - u(k,j,i) ) * ddy       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 1 ) )
           ENDIF
 !
@@ -214,8 +234,12 @@
           IF ( wkomp > 0.0_wp )  THEN
              tend(k,j,i) = tend(k,j,i) - wkomp *                               &
-                                         ( u(k,j,i) - u(k-1,j,i) ) * ddzu(k)
+                                         ( u(k,j,i) - u(k-1,j,i) ) * ddzu(k)   &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 1 ) )
           ELSE
              tend(k,j,i) = tend(k,j,i) - wkomp *                               &
-                                         ( u(k+1,j,i) - u(k,j,i) ) * ddzu(k+1)
+                                         ( u(k+1,j,i) - u(k,j,i) ) * ddzu(k+1) &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 1 ) )
           ENDIF
 
Index: /palm/trunk/SOURCE/advec_v_pw.f90
===================================================================
--- /palm/trunk/SOURCE/advec_v_pw.f90	(revision 2231)
+++ /palm/trunk/SOURCE/advec_v_pw.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! topography representation via flags
 ! 
 ! Former revisions:
@@ -96,5 +96,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxr, nyn, nysv, nzb_v_inner, nzt
+           ONLY:  nxl, nxr, nyn, nysv, nzb, nzt, wall_flags_0
 
        USE kinds
@@ -115,5 +115,5 @@
        DO  i = nxl, nxr
           DO  j = nysv, nyn
-             DO  k = nzb_v_inner(j,i)+1, nzt
+             DO  k = nzb+1, nzt
                 tend(k,j,i) = tend(k,j,i) - 0.25_wp * (                        &
                          ( v(k,j,i+1) * ( u(k,j-1,i+1) + u(k,j,i+1) - gu )     &
@@ -124,5 +124,7 @@
                          - v(k-1,j,i) * ( w(k-1,j-1,i) + w(k-1,j,i) ) )        &
                                                                   * ddzw(k)    &
-                                                      )
+                                                      )                        &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 2 ) )
              ENDDO
           ENDDO
@@ -149,5 +151,5 @@
 
        USE indices,                                                            &
-           ONLY:  nzb_v_inner, nzt
+           ONLY:  nzb, nzt, wall_flags_0
 
        USE kinds
@@ -166,5 +168,5 @@
        gu = 2.0_wp * u_gtrans
        gv = 2.0_wp * v_gtrans
-       DO  k = nzb_v_inner(j,i)+1, nzt
+       DO  k = nzb+1, nzt
           tend(k,j,i) = tend(k,j,i) - 0.25_wp * (                              &
                          ( v(k,j,i+1) * ( u(k,j-1,i+1) + u(k,j,i+1) - gu )     &
@@ -175,5 +177,7 @@
                          - v(k-1,j,i) * ( w(k-1,j-1,i) + w(k-1,j,i) ) )        &
                                                                   * ddzw(k)    &
-                                                )
+                                                )                              &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 2 ) )
        ENDDO
  
